//<c>   Copyright 1990-1999 by Gerry J. Danen; all rights reserved.

//<t>   Right-justify lines

#include"gd_tools.h"


#define pgVERS_ "V3.00"
#define pgTITL_ "Right-Justify Lines"
#define pgCOPR_ "1990"


#define BUFSIZE 10241
char    buf[BUFSIZE], buf1[BUFSIZE] ;


UINT    siz_out = 80 ;                  //  width of lines to go to output file
FILE    *iFh, *oFh ;
UCHAR   oFile[FS_LEN] ;


void    help( void )
{
    logon(1);
    printf( "\nUsage:\n\t%s [switch(es)] [fspec] [fspec] ...\n\n"
            "\twhere\t[fspec] means a DOS file specification\n\t\t[switch]"
            " /s = size of output line\n"
            "\t\t\t /o = name of output file\n\n"
            "Note that by specifying several file specs, you will be adding all files\n"
            "to the output file.\n\n"
            "Blank lines are dropped.\n\n", get_global_program_name() );
    exit( GD_ERROR_HELP );
}


void    rjust( char *f )
{
    char        *p ;

    while ( (p = fgets( buf1, BUFSIZE, iFh )) )
    {
        st_trim( buf1 );
        StrDetab( buf, buf1, BUFSIZE );
        if ( strlen( buf ) )
            fprintf( oFh, "%*s\n", siz_out, buf );
    }
}


void    main( int argc, char *argv[] )
{
    STRING      s ;
    int         x=1 ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc < 2 )
        help();

    st_cpy( oFile, "rjust.txt", FS_LEN );

    //  process switches
    while ( --argc > 0 && (**++argv == '-' || **argv == '/') )
    {
        for ( s = *argv+1 ; *s ; ++s )
        {
            switch( tolower(*s) )
            {
                case 's' :                      // size of output line
                    if ( ++*s == '=' )
                    {
                        *s++ ;
                        siz_out = atoi( s );
                    }
                    else
                        fprintf( stderr, "---> ERROR: invalid S option\n" );
                    break;
                case 'o' :                      // output file name
                    if ( ++*s == '=' )
                    {
                        *s++ ;
                        st_cpy( oFile, s, FS_LEN );
                    }
                    else
                        fprintf( stderr, "---> ERROR: invalid O option\n" );
                    break;
                default :
                    fprintf( stderr, "---> ERROR: bad option: /%c\n", *s );
                    exit( 1 );
            }
        }
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

    //  process files
    if ( argc != 0 )
    {
        for ( ; *argv ; ++argv )
        {
            if ( ( iFh = fopen( *argv, "r" ) ) == NULL )
            {
                fprintf( stderr, "Cannot open file %s\a\n", *argv );
            }
            else
            {
                rjust( *argv );
                fclose( iFh );
            }
        }
    }

    fclose( oFh );

    exit( GD_ERROR_NONE );
}
